unit XDBGridUnit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, XDBGrids, ExtCtrls, StdCtrls;

type
  TXDBGridForm2 = class(TForm)
    DataSource1: TDataSource;
      Table1: TTable;
    DataSource2: TDataSource;
      Query2: TQuery;
    DataSource3: TDataSource;
      Query3: TQuery;
    OrdersPanel: TPanel;
      XDBGrid1: TXDBGrid;
      FooterPanel: TPanel;
        XDBGrid2: TXDBGrid;      
        XDBGrid3: TXDBGrid;
    CommentsPanel: TPanel;
      Label1: TLabel;
      Label2: TLabel;
      Label3: TLabel;
      Label4: TLabel;
      Bevel1: TBevel;
      Bevel2: TBevel;
      Bevel3: TBevel;
      Bevel4: TBevel;
      Label5: TLabel;
      Label6: TLabel;
      Label7: TLabel;
      Label8: TLabel;
      Label9: TLabel;
      Label10: TLabel;
      Label11: TLabel;
      Label12: TLabel;
      Button1: TButton;
      Button2: TButton;
    procedure Table1AfterChange(DataSet: TDataSet);
    procedure Table1BeforeInsert(DataSet: TDataSet);
    procedure XDBGrid1PaintColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TXColumn; Highlight: Boolean;
      var Color: TColor; Font: TFont; var Image: TPersistent);
    procedure XDBGrid1ColumnMoving(Sender: TObject; FromIndex,
      ToIndex: Integer; var Accept: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  end;

var
  XDBGridForm2: TXDBGridForm2;

implementation

{$R *.DFM}

procedure TXDBGridForm2.Table1AfterChange(DataSet: TDataSet);
begin
  Query2.DisableControls;
  Query3.DisableControls;
  try
    Query2.Close;
    Query2.Open;
    Query3.Close;
    Query3.Open;
  finally
    Query2.EnableControls;
    Query3.EnableControls;
  end;
end;

procedure TXDBGridForm2.Table1BeforeInsert(DataSet: TDataSet);
begin
  Abort;
end;

procedure TXDBGridForm2.XDBGrid1PaintColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TXColumn; Highlight: Boolean;
  var Color: TColor; Font: TFont; var Image: TPersistent);
begin
  if not Highlight then
    if Odd(Table1.RecNo) then Color := clGreen
    else Color := clOlive
  else Font.Style := [fsBold];
end;

procedure TXDBGridForm2.XDBGrid1ColumnMoving(Sender: TObject; FromIndex,
  ToIndex: Integer; var Accept: Boolean);
begin
  Accept := (FromIndex > 0) and (ToIndex > 0); {Don't move first column}
end;

procedure TXDBGridForm2.Button1Click(Sender: TObject);
var
  Column: TXColumn;
begin
  Column := XDBGrid1.ColumnByName('TaxRate');
  Column.Visible := not Column.Visible;
  if Column.Visible then Button1.Caption := 'Hide TaxRate'
  else Button1.Caption := 'Show TaxRate';
end;

procedure TXDBGridForm2.Button2Click(Sender: TObject);
begin
  with XDBGrid2 do
  begin
    if MasterGrid <> nil then MasterGrid := nil else MasterGrid := XDBGrid1;
    if MasterGrid <> nil then Button2.Caption := 'Synchronize OFF'
    else Button2.Caption := 'Synchonize ON';
  end;
end;

end.
